package cooperari.pppj14;

/**
 * Buggy semaphore implementation, version 1.
 * 
 * Bugs in up(): unsynchronized access to
 * value and two-stage access pattern.
 * 
 * @author Eduardo Marques, DI/FCUL, 2014
 *
 */
public class BuggySemaphore1 implements Semaphore {
	private int value;
	
	public BuggySemaphore1(int initial) { 
		value = initial; 
	}
	
	public int getValue()  { 
		return value; 
	}
	
	public void down() 
			throws InterruptedException {
		synchronized (this) {
			while (value == 0) {
				wait();
			}      
			value = value - 1; 
		}
	}
	public void up() {
		synchronized (this) { 
			value = value + 1; 
		}
		if (value == 1) {
			synchronized(this) { 
				notify(); 
			}
		}
	}
}
