package cooperari.pppj14;

/**
 * Buggy semaphore implementation, version 2.
 * 
 * Bug in up():  two-stage access pattern.
 * 
 * @author Eduardo Marques, DI/FCUL, 2014
 *
 */
public class BuggySemaphore2 implements Semaphore {
 
  private int value;

  public BuggySemaphore2(int initial) {
    value = initial;
  }
  
  @Override
  public int getValue() {
    return value;
  }
  @Override
  public void down() throws InterruptedException {
    synchronized (this) {
      while (value == 0) {
        wait();
      }
      value = value - 1;
    }
  }
  @Override
  public void up() {
    synchronized (this) {
      value = value + 1;
    }
    synchronized (this) {
      if (value == 1) {
        notify();
      }
    }
  }
}
