package cooperari.pppj14;

/**
 * Buggy semaphore implementation, version 3.
 * 
 * Bug in up():  unsynchronized value increment.
 * 
 * @author Eduardo Marques, DI/FCUL, 2014
 *
 */
public class BuggySemaphore3 implements Semaphore {

  private int value;

  public BuggySemaphore3(int initial) {
    value = initial;
  }

  @Override
  public int getValue() {
    return value;
  }

  @Override
  public void down() throws InterruptedException {
    synchronized (this) {
      while (value == 0) {
        wait();
      }
      value = value - 1;
    }
  }

  @Override
  public void up() {
    value = value + 1;
    synchronized (this) {
      if (value == 1) {
        notify();
      }
    }
  }
}
