package cooperari.pppj14;

/**
 * Buggy semaphore implementation, version 4.
 * 
 * Bug in up():  the method uses no synchronization at all.
 * 
 * @author Eduardo Marques, DI/FCUL, 2014
 *
 */
public class BuggySemaphore4 implements Semaphore {

  private int value;

  public BuggySemaphore4(int initial) {
    value = initial;
  }

  @Override
  public int getValue() {
    return value;
  }

  @Override
  public void down() throws InterruptedException {
    synchronized (this) {
      while (value == 0) {
        wait();
      }
      value = value - 1;
    }
  }

  @Override
  public void up() {
    value = value + 1;
    if (value == 1)
      notify();
  }
}
