package cooperari.pppj14;

/**
 * Buggy semaphore implementation, version 5.
 * 
 * Bug in up():  notification is not done.
 * 
 * @author Eduardo Marques, DI/FCUL, 2014
 *
 */
public class BuggySemaphore5 implements Semaphore {

  private int value;

  public BuggySemaphore5(int initial) {
    value = initial;
  }

  @Override
  public int getValue() {
    return value;
  }

  @Override
  public void down() throws InterruptedException {
    synchronized (this) {
      while (value == 0) {
        wait();
      }
      value = value - 1;
    }
  }

  @Override
  public void up() {
    synchronized (this) {
      value = value + 1;
      if (value == 1) {
        // Notification not done.
        // notify();
      }
    }
  }
}
