package cooperari.pppj14;

/**
 * A correct semaphore implementation.
 * 
 * @author Eduardo Marques, DI/FCUL, 2014
 *
 */
public class CorrectSemaphore implements Semaphore {
 
  private int value;

  public CorrectSemaphore(int initial) {
    value = initial;
  }

  @Override
  public int getValue() {
    return value;
  }

  @Override
  public void down() throws InterruptedException {
    synchronized (this) {
      while (value == 0) {
        wait();
      }
      value = value - 1;
    }
  }

  @Override
  public void up() {
    synchronized (this) {
      value = value + 1;
      if (value == 1) {
        notify();
      }
    }
  }
}
