package cooperari.aspectj;

import cooperari.core.CThread;

aspect ArrayAccess {

  before (Object o, int index) : arrayget() && target(o) && args(index) {
    CThread t = CThread.intercept(thisJoinPoint, o.getClass());
    if (t != null) {
      t.beginRead(o, index);
    }
  }

  after (Object o, int index) : arrayget() && target(o) && args(index) {
    CThread t = CThread.intercept(thisJoinPoint, o.getClass());
    if (t != null) {
      t.endRead(o, index);
    }
  }

  before (Object o, int index) : arrayset() && target(o) && args(index) {
    CThread t = CThread.intercept(thisJoinPoint, o.getClass());
    if (t != null) {
      t.beginWrite(o, index);
    }
  }

  after (Object o, int index) : arrayset() && target(o) && args(index) {
    CThread t = CThread.intercept(thisJoinPoint, o.getClass());
    if (t != null) {
      t.endWrite(o, index);
    }
  }
}
