package cooperari.aspectj;

import cooperari.core.CThread;

/**
 * Field acess instrumentation.
 */
aspect FieldAccess {
  
  before(Object o) : get(* *.*) && !within(cshe.aspectj) && target(o) {
    CThread t = CThread.intercept(thisJoinPoint);
    if (t != null) {
      t.beginRead(o,thisJoinPoint.getSignature().getName());
    }
  }
  after(Object o) : get(* *.*) && !within(cooperari.aspectj) && target(o) {
    CThread t = CThread.intercept(thisJoinPoint);
    if (t != null) {
      t.endRead(o,thisJoinPoint.getSignature().getName());
    }
  }

  before(Object o) : set(* *.*) && !within(cooperari.aspectj) && target(o) {
    CThread t = CThread.intercept(thisJoinPoint);
    if (t != null) {
      t.beginWrite(o,thisJoinPoint.getSignature().getName());
    }
  }

  after(Object o) : set(* *.*) && !within(cooperari.aspectj) && target(o) {
    CThread t = CThread.intercept(thisJoinPoint);
    if (t != null) {
      t.endWrite(o,thisJoinPoint.getSignature().getName());
    }
  }
}
